<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListaDecV4Sal StructType
 * Meta information extracted from the WSDL
 * - type: ListaDecV4Sal:ListaDecV4Sal
 * @subpackage Structs
 */
class ListaDecV4Sal extends AbstractStructBase
{
    /**
     * The declaracion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DeclaracionType[]
     */
    public $declaracion;
    /**
     * Constructor method for ListaDecV4Sal
     * @uses ListaDecV4Sal::setDeclaracion()
     * @param \StructType\DeclaracionType[] $declaracion
     */
    public function __construct(array $declaracion = array())
    {
        $this
            ->setDeclaracion($declaracion);
    }
    /**
     * Get declaracion value
     * @return \StructType\DeclaracionType[]|null
     */
    public function getDeclaracion()
    {
        return $this->declaracion;
    }
    /**
     * This method is responsible for validating the values passed to the setDeclaracion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeclaracion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeclaracionForArrayConstraintsFromSetDeclaracion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $listaDecV4SalDeclaracionItem) {
            // validation for constraint: itemType
            if (!$listaDecV4SalDeclaracionItem instanceof \StructType\DeclaracionType) {
                $invalidValues[] = is_object($listaDecV4SalDeclaracionItem) ? get_class($listaDecV4SalDeclaracionItem) : sprintf('%s(%s)', gettype($listaDecV4SalDeclaracionItem), var_export($listaDecV4SalDeclaracionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The declaracion property can only contain items of type \StructType\DeclaracionType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set declaracion value
     * @throws \InvalidArgumentException
     * @param \StructType\DeclaracionType[] $declaracion
     * @return \StructType\ListaDecV4Sal
     */
    public function setDeclaracion(array $declaracion = array())
    {
        // validation for constraint: array
        if ('' !== ($declaracionArrayErrorMessage = self::validateDeclaracionForArrayConstraintsFromSetDeclaracion($declaracion))) {
            throw new \InvalidArgumentException($declaracionArrayErrorMessage, __LINE__);
        }
        $this->declaracion = $declaracion;
        return $this;
    }
    /**
     * Add item to declaracion value
     * @throws \InvalidArgumentException
     * @param \StructType\DeclaracionType $item
     * @return \StructType\ListaDecV4Sal
     */
    public function addToDeclaracion(\StructType\DeclaracionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeclaracionType) {
            throw new \InvalidArgumentException(sprintf('The declaracion property can only contain items of type \StructType\DeclaracionType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->declaracion[] = $item;
        return $this;
    }
}
